#include <bits/stdc++.h>
using namespace std;

#define int long long

const int N = 30, mod = 1e9 + 7;

int n, k;
int a[N], b[N][N];
int ans = 0;

void rec(int i, int sum) {
    if (i == n) {
        ans++;
        return;
    }
    int x = k - 1, y = i - 1;
    while (x >= 0 && y >= 0) {
        sum -= b[y][x];
        x--, y--;
    }
    for (int p = 0; p < (1 << k); ++p) {
        int cnt = 0;
        for (int j = 0; j < 8; ++j) {
            cnt += ((p >> j) & 1);
        }
        if (cnt + sum == a[i]) {
            for (int j = 0; j < N; ++j) {
                b[i][j] = ((p >> j) & 1);
            }
            rec(i + 1, sum + cnt);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (k > 2) {
        rec(0, 0);
        cout << ans;
    } else if (k == 2) {
        int dp[n][4];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < 4; ++j) {
                dp[i][j] = 0;
            }
        }
        if (a[0] == 0) {
            dp[0][0] = 1;
        } else if (a[0] == 1) {
            dp[0][1] = 1;
            dp[0][2] = 1;
        } else if (a[0] == 2) {
            dp[0][3] = 1;
        } else {
            cout << 0;
            return 0;
        }
        for (int i = 1; i < n; ++i) {
            if (a[i] == 0) {
                dp[i][0] = dp[i - 1][0] + dp[i - 1][2];
            } else if (a[i] == 1) {
                dp[i][0] = dp[i - 1][1] + dp[i - 1][3];
                dp[i][1] = dp[i - 1][2] + dp[i - 1][0];
                dp[i][2] = dp[i - 1][2] + dp[i - 1][0];
            } else if (a[i] == 2) {
                dp[i][1] = dp[i - 1][1] + dp[i - 1][3];
                dp[i][2] = dp[i - 1][1] + dp[i - 1][3];
                dp[i][3] = dp[i - 1][0] + dp[i - 1][2];
            } else if (a[i] == 3) {
                dp[i][3] = dp[i - 1][1] + dp[i - 1][3];
            } else {
                cout << 0;
                return 0;
            }
            for (int o = 0; o < 4; ++o) {
                dp[i][o] %= mod;
            }
        }
        for (int i = 0; i < 4; ++i) {
            ans += dp[n - 1][i];
        }
        cout << ans % mod;
    } else {
        for (int i = 0; i < n; ++i) {
            if (a[i] > 1) {
                cout << 0;
                return 0;
            }
        }
        cout << 1;
    }
    return 0;
}
