#include <bits/stdc++.h>
using namespace std;

#define int long long

const int N = 1e5 + 10;

vector<int> a[N];
int n, s;

void n_1() {
    int k = (int) a[0].size();
    vector<int> b = a[0];
    bool dp[k][s + 1];
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= s; ++j) {
            dp[i][j] = false;
        }
    }
    for (int i = 0; i < k; ++i) {
        if (b[i] <= s) dp[i][b[i]] = true;
    }
    for (int i = 1; i < k; ++i) {
        for (int j = 0; j <= s; ++j) {
            if (dp[i][j]) continue;
            if (j - b[i] >= 0) dp[i][j] = dp[i - 1][j - b[i]];
            if (dp[i - 1][j]) {
                dp[i][j] = true;
            }
        }
    }
    if (dp[k - 1][s]) {
        cout << "Yes\n";
        stack<int> out;
        int x = k - 1, y = s;
        while (y != 0) {
            if (x == 0 || !dp[x - 1][y]) {
                out.push(x + 1);
                y -= b[x];
            }
            x--;
        }
        cout << out.size() << '\n';
        while (!out.empty()) {
            cout << out.top() << ' ';
            out.pop();
        }
    } else {
        cout << "No";
    }
}

void n_2() {
    int k1 = (int) a[0].size();
    vector<int> b1 = a[0];
    bool dp1[k1][s + 1];
    for (int i = 0; i < k1; ++i) {
        for (int j = 0; j <= s; ++j) {
            dp1[i][j] = false;
        }
    }
    for (int i = 0; i < k1; ++i) {
        if (b1[i] <= s) dp1[i][b1[i]] = true;
    }
    for (int i = 1; i < k1; ++i) {
        for (int j = 0; j <= s; ++j) {
            if (dp1[i][j]) continue;
            if (j - b1[i] >= 0) dp1[i][j] = dp1[i - 1][j - b1[i]];
            if (dp1[i - 1][j]) {
                dp1[i][j] = true;
            }
        }
    }
    int k2 = (int) a[1].size();
    vector<int> b2 = a[1];
    bool dp2[k2][s + 1];
    for (int i = 0; i < k2; ++i) {
        for (int j = 0; j <= s; ++j) {
            dp2[i][j] = false;
        }
    }
    for (int i = 0; i < k2; ++i) {
        if (b2[i] <= s) dp2[i][b2[i]] = true;
    }
    for (int i = 1; i < k2; ++i) {
        for (int j = 0; j <= s; ++j) {
            if (dp2[i][j]) continue;
            if (j - b2[i] >= 0) dp2[i][j] = dp2[i - 1][j - b2[i]];
            if (dp2[i - 1][j]) {
                dp2[i][j] = true;
            }
        }
    }
    for (int i = 1; i < s; ++i) {
        if (dp1[k1 - 1][i] && dp2[k2 - 1][s - i]) {
            cout << "Yes\n";
            stack<int> fir, sec;
            int x = k1 - 1, y = i;
            while (y != 0) {
                if (x == 0 || !dp1[x - 1][y]) {
                    fir.push(x + 1);
                    y -= b1[x];
                }
                x--;
            }
            x = k2 - 1, y = s - i;
            while (y != 0) {
                if (x == 0 || !dp2[x - 1][y]) {
                    sec.push(x + 1);
                    y -= b2[x];
                }
                x--;
            }
            cout << fir.size() << '\n';
            while (!fir.empty()) {
                cout << fir.top() << ' ';
                fir.pop();
            }
            cout << '\n' << sec.size() << '\n';
            while (!sec.empty()) {
                cout << sec.top() << ' ';
                sec.pop();
            }
            return;
        }
    }
    cout << "No";
}

int b[25];

void mask(int i) {
    if (i == n) {
        int sum = 0;
        int cnt[25];
        for (int j = 0; j < n; ++j) {
            vector<int> c = a[j];
            int k = (int) c.size();
            for (int l = 0; l < k; ++l) {
                if ((b[j] >> l) & 1) {
                    sum += c[l];
                    cnt[j]++;
                }
            }
        }
        if (sum == s) {
            cout << "Yes\n";
            for (int j = 0; j < n; ++j) {
                cout << cnt[j] << '\n';
                int k = (int) a[j].size();
                for (int l = 0; l < k; ++l) {
                    if ((b[j] >> l) & 1) {
                        cout << l + 1 << ' ';
                    }
                }
                cout << '\n';
            }
        }
        return;
    }
    int k = (int) a[i].size();
    for (int j = 1; j < (1 << k); ++j) {
        b[i] = k;
        mask(i + 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> s;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            a[i].push_back(x);
            sum += x;
        }
    }
    if (sum == s) {
        cout << "Yes\n";
        for (int i = 0; i < n; ++i) {
            cout << a[i].size() << '\n';
            for (int j = 0; j < a[i].size(); ++j) {
                cout << j + 1 << ' ';
            }
            cout << '\n';
        }
        return 0;
    }
    if (n == 1) {
        n_1();
        return 0;
    }
    if (n == 2) {
        n_2();
        return 0;
    }
    mask(0);
    cout << "No";
    return 0;
}
